commit d0e8d7719d5410831bb7f4b558fceee51a88fb5b
Author: Hasso Tepper <hasso@estpak.ee>
Date:   Tue May 12 14:16:25 2009 +0300

    Make pthread types visible via sys/types.h to conform SUSv3.
    
    Mobe pthread types to _pthreadtypes.h. and include it from sys/types.h.
    pthread.h should do same, but as it includes sys/types.h now, don't
    touch it yet.
    
    Inspired-by: FreeBSD

diff --git a/include/pthread.h b/include/pthread.h
index b623804..9d0f06e 100644
--- a/include/pthread.h
+++ b/include/pthread.h
@@ -84,60 +84,6 @@
 #define PTHREAD_CANCELED		((void *) 1)
 
 /*
- * Forward structure definitions.
- *
- * These are mostly opaque to the user.
- */
-struct pthread;
-struct pthread_attr;
-struct pthread_cond;
-struct pthread_cond_attr;
-struct pthread_mutex;
-struct pthread_mutex_attr;
-struct pthread_once;
-struct pthread_rwlock;
-struct pthread_rwlockattr;
-struct pthread_barrier;
-struct pthread_barrier_attr;
-
-/*
- * Primitive system data type definitions required by P1003.1c.
- *
- * Note that P1003.1c specifies that there are no defined comparison
- * or assignment operators for the types pthread_attr_t, pthread_cond_t,
- * pthread_condattr_t, pthread_mutex_t, pthread_mutexattr_t.
- */
-typedef struct	pthread			*pthread_t;
-typedef struct	pthread_attr		*pthread_attr_t;
-typedef struct	pthread_mutex		*pthread_mutex_t;
-typedef struct	pthread_mutex_attr	*pthread_mutexattr_t;
-typedef struct	pthread_cond		*pthread_cond_t;
-typedef struct	pthread_cond_attr	*pthread_condattr_t;
-typedef int     			pthread_key_t;
-typedef struct	pthread_once		pthread_once_t;
-typedef struct	pthread_rwlock		*pthread_rwlock_t;
-typedef struct	pthread_rwlockattr	*pthread_rwlockattr_t;
-typedef struct	pthread_barrier		*pthread_barrier_t;
-typedef struct	pthread_barrierattr	*pthread_barrierattr_t;
-
-/*
- * Additional type definitions:
- *
- * Note that P1003.1c reserves the prefixes pthread_ and PTHREAD_ for
- * use in header symbols.
- */
-typedef void	*pthread_addr_t;
-typedef void	*(*pthread_startroutine_t) (void *);
-
-/*
- * Once definitions.
- */
-struct pthread_once {
-	int		state;
-	pthread_mutex_t	mutex;
-};
-
-/*
  * Flags for once initialization.
  */
 #define PTHREAD_NEEDS_INIT  0
diff --git a/sys/sys/_pthreadtypes.h b/sys/sys/_pthreadtypes.h
new file mode 100644
index 0000000..7c32637
--- /dev/null
+++ b/sys/sys/_pthreadtypes.h
@@ -0,0 +1,91 @@
+/*
+ * Copyright (c) 1993, 1994 by Chris Provenzano, proven@mit.edu
+ * Copyright (c) 1995-1998 by John Birrell <jb@cimlogic.com.au>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *    This product includes software developed by Chris Provenzano.
+ * 4. The name of Chris Provenzano may not be used to endorse or promote
+ *    products derived from this software without specific prior written
+ *    permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY CHRIS PROVENZANO ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL CHRIS PROVENZANO BE LIABLE FOR ANY
+ * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
+ * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _SYS__PTHREADTYPES_H_
+#define _SYS__PTHREADTYPES_H_
+
+/*
+ * Forward structure definitions.
+ *
+ * These are mostly opaque to the user.
+ */
+struct pthread;
+struct pthread_attr;
+struct pthread_cond;
+struct pthread_cond_attr;
+struct pthread_mutex;
+struct pthread_mutex_attr;
+struct pthread_once;
+struct pthread_rwlock;
+struct pthread_rwlockattr;
+struct pthread_barrier;
+struct pthread_barrier_attr;
+
+/*
+ * Primitive system data type definitions required by P1003.1c.
+ *
+ * Note that P1003.1c specifies that there are no defined comparison
+ * or assignment operators for the types pthread_attr_t, pthread_cond_t,
+ * pthread_condattr_t, pthread_mutex_t, pthread_mutexattr_t.
+ */
+typedef struct	pthread			*pthread_t;
+typedef struct	pthread_attr		*pthread_attr_t;
+typedef struct	pthread_mutex		*pthread_mutex_t;
+typedef struct	pthread_mutex_attr	*pthread_mutexattr_t;
+typedef struct	pthread_cond		*pthread_cond_t;
+typedef struct	pthread_cond_attr	*pthread_condattr_t;
+typedef int				pthread_key_t;
+typedef struct	pthread_once		pthread_once_t;
+typedef struct	pthread_rwlock		*pthread_rwlock_t;
+typedef struct	pthread_rwlockattr	*pthread_rwlockattr_t;
+typedef struct	pthread_barrier		*pthread_barrier_t;
+typedef struct	pthread_barrierattr	*pthread_barrierattr_t;
+
+/*
+ * Additional type definitions:
+ *
+ * Note that P1003.1c reserves the prefixes pthread_ and PTHREAD_ for
+ * use in header symbols.
+ */
+typedef void    *pthread_addr_t;
+typedef void    *(*pthread_startroutine_t) (void *);
+
+/*
+ * Once definitions.
+ */
+struct pthread_once {
+	int		state;
+	pthread_mutex_t	mutex;
+};
+
+#endif /* ! _SYS__PTHREADTYPES_H_ */
diff --git a/sys/sys/types.h b/sys/sys/types.h
index b65800a..bdaa8a5 100644
--- a/sys/sys/types.h
+++ b/sys/sys/types.h
@@ -58,6 +58,9 @@
 #ifndef _MACHINE_TYPES_H_
 #include <machine/types.h>
 #endif
+#ifndef _SYS__PTHREADTYPES_H_
+#include <sys/_pthreadtypes.h>
+#endif
 
 #ifndef _POSIX_SOURCE
 typedef	unsigned char	u_char;
